/*
 * just an easy to use spline routine
 *
 * leto/calodox, 02.2002
 *
 */

#include "ezspline.h"

#include <assert.h>

void splineCompute(float t, int dim, float *prev, float *a, float *b, float *next, float *result)
{
	float t2 = t*t;
	float t3 = t2*t;

	float h1 = 2.0*t3 -3.0*t2 + 1;
	float h2 = -2*t3 + 3*t2;
	float h3 = t3 -2*t2 + t;
	float h4 = t3-t2;

	float *p, *n;
	int i;

	assert(dim < MAX_SPLINE_DIM);

	if (prev) 
		p = prev;
	else 
		p = a;

	if (next)
		n = next;
	else
		n = b;
	
	for (i=0; i<dim; i++) {
		// compute tg
		float t1, t2;

		t1 = b[i] - p[i];

		t2 = - a[i] + n[i];

		result[i] = 
			h1*a[i] +
			h3*t1 + 
			h4*t2 + 
			h2*b[i]; 
	}
}