/*
 * Race track generator
 *
 * leto/calodox, 02.2002
 */

#ifndef _TRACKGEN_H_
#define _TRACKGEN_H_


class TrackGenerator {
public:

	// parameters for generating the track.
	int nbSeg;
	float curveTrig;
	float keyDist;

	// generates the spline keys.
	// a level of 0 will give a simple track,
	// complexity will grow with 'level'.
	void generateKeys(int level);

	// call this function to generate the track.
	// it will respond by calling addTriangle()
	void generateTrack();

private:

	float position[3];
	float angle;
	void ruleA(int level);
	void advance();
	void putKey();
	void turn(float a) { angle += a; }
};

// triangles are sent through this function.
// define it somewhere.
extern void addTriangle(float *v1, float *v2, float *v3, int type);

#endif
