/*
 * Duration Properties dialog for calodox Demoniac
 *
 * Julien Pilet <leto@calodox.org>, 12.2001
 */

#ifndef _DURATIONDLG_H_
#define _DURATIONDLG_H_

#include "duration.h"
#include "dlg.h"

//! This class provide a properties window for Duration.
class DurationDlg : public Dlg {
private:

	Duration *duration;

	GtkWidget *nameEntry;
	GtkAdjustment *initTimeAdj;
	GtkAdjustment *startTimeAdj;
	GtkAdjustment *durationAdj;

	GtkWidget *containerFrame;
	GtkWidget *loopCheckButton;

	static void cbRenameDuration(GtkWidget *widget, DurationDlg *dlg);
	static void cbInitChanged(GtkAdjustment *widget, DurationDlg *dlg);
	static void cbStartChanged(GtkAdjustment *widget, DurationDlg *dlg);
	static void cbDurationChanged(GtkAdjustment *widget, DurationDlg *dlg);
	static void cbLoopToggled(GtkToggleButton *toggle, DurationDlg *dlg);
public:

	DurationDlg();
	virtual ~DurationDlg();

	virtual void build();
	virtual const char *getName();
	
	void setDuration(Duration *d);
	void updateGui();
};

#endif
