/*
 * Duration factory for calodox demoniac
 *
 * Julien Pilet <leto@calodox.org> 12.2001
 */

#ifndef _DURATIONFACTORY_H_
#define _DURATIONFACTORY_H_

#include <vector>
#include "duration.h"
#include "loader.h"

typedef Duration * (*DurationConstructor)();

//! this class describe a duration class, and is able to create
//  a new object as described.
class DurationMaker {
public:

	typedef enum { NONE, EFFECT } durationType;

	DurationConstructor constructor;
	char *name;
	char *description;
	durationType type;

	DurationMaker(DurationConstructor c, const char *name, 
			const char *description, durationType type = NONE); 
	~DurationMaker();
};


class DurationFactory {
private:

public:
	std::vector<DurationMaker *> makers;

	DurationFactory();
	~DurationFactory();

	void addDurationMaker( DurationMaker *maker);

	Duration *create(const char *name, Loader *l=0);

};

#endif

