/*
 * Calodox Demoniac file support
 * (c) 2001 Stephane Magnenat, Julien Pilet, Ysagoon
 */

#ifndef _FILEMANAGER_H_
#define _FILEMANAGER_H_

#include <stdio.h>
#include <vector>

#ifndef DIR_SEPARATOR
#define DIR_SEPARATOR '/'
#endif

class FileManager 
{
private:
	std::vector<char *> dirList;		

public:
	//! the default constructor will add
	// a few directories in the dirList. At least "."
	FileManager();
	virtual ~FileManager();

	//! append a directory to the search list.
	void addDir(const char *dir);

	char *find(const char *filename, const char *subdir=0, const char *mode="r");
	FILE *open(const char *filename, const char *subdir=0, const char *mode="r");
};

#endif
