/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Option: options for FXs in GLDemoniac.
 * Leto/calodox, 12.2000
 */

#include <string.h>
#include <assert.h>
#include <matvect.h>
#include "glmain.h"
#include "saver.h"
#include "genericoption.h"
#include "track.h"
#include "interpolator.h"
#include "optval.h"
#include "report.h"

/*******************
 * Generic Option  *
 ******************/

// Constructor
GenericOption::GenericOption(FXInstance *owner, char *name, char *defName, int flags) :
	owner(owner),
	flags(flags),
	ignore(false),
	treeItem(0)
{
	setName(name, defName);
}

GtkBox *GenericOption::drawLabel(GtkBox *box) {
	ignore = false; 

	GtkWidget *hbox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(box, hbox, FALSE, FALSE, 0);

	// label
	GtkWidget *label = gtk_label_new(name);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 5);
	
	return GTK_BOX(hbox);
}	

void GenericOption::setName (const char *newName, const char *def) {
	const char *str;

	str = newName ? newName : def;

	name = new char[strlen(str)+1];
	strcpy(name, str);
}

