/*
 * TooBar for Calodox Demoniac
 *
 * Julien Pilet <leto@calodox.org>, 12.2001
 */

#include <gtk/gtk.h>
#include "glmain.h"

GtkWidget *Toolbar::create(GtkWidget *window) {
	
	GtkWidget *hbox = gtk_hbox_new(FALSE, FALSE);

	gtk_container_set_border_width(GTK_CONTAINER(hbox), 2);

	GtkWidget *label = gtk_label_new("Demo time");
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 5);
	gtk_widget_show(label);

	GtkAdjustment *timeAdjustment = glMainptr->getTimeAdjustment();

	timeSpinner = gtk_spin_button_new(timeAdjustment, 1, 3);
	gtk_spin_button_set_digits(GTK_SPIN_BUTTON(timeSpinner), 2);
	gtk_widget_set_usize(timeSpinner, 100, -2);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(timeSpinner), TRUE);
	gtk_signal_connect(GTK_OBJECT(timeAdjustment), "value_changed",
		GTK_SIGNAL_FUNC(cbDemoTime), timeSpinner);
	gtk_box_pack_start(GTK_BOX(hbox), timeSpinner, FALSE, FALSE, 5);
	gtk_widget_show(timeSpinner);

	GtkWidget *playStopButton = gtk_button_new();
	gtk_container_set_border_width(GTK_CONTAINER(playStopButton), 2);
	playStopButtonLabel = gtk_label_new("Play");
	gtk_widget_show(playStopButtonLabel);

	gtk_container_add(GTK_CONTAINER(playStopButton), playStopButtonLabel);
	gtk_box_pack_start(GTK_BOX(hbox), playStopButton, FALSE, FALSE, 5);
	gtk_signal_connect(GTK_OBJECT(playStopButton), "clicked",
			GTK_SIGNAL_FUNC(cbPlayStopButton), this);
	gtk_widget_show(playStopButton);

	return hbox;
}

void Toolbar::setPlayStopLabel(const char *name) {
	gtk_label_set_text(GTK_LABEL(playStopButtonLabel), name);
}

